OGRE: Ogre::GLSLProgram Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | Public Attributes | List of all members
Ogre::GLSLProgram Class Referenceabstract

C++ encapsulation of GLSL program object. More...

`#include <OgreGLSLProgram.h>`

Inheritance diagram for Ogre::GLSLProgram:
[legend]

## Public Member Functions
| GLSLProgram (GLSLShader *vertexProgram, GLSLShader *hullProgram, GLSLShader *domainProgram, GLSLShader *geometryProgram, GLSLShader *fragmentProgram, GLSLShader *computeProgram)
| Constructor should only be used by GLSLMonolithicProgramManager and GLSLSeparableProgramManager. More...
virtual | ~GLSLProgram (void)
virtual void | activate (void)=0
| Makes a program object active by making sure it is linked and then putting it in use. More...
virtual void | extractLayoutQualifiers (void)
| Finds layout qualifiers in the shader source and sets attribute indices appropriately. More...
virtual GLint | getAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the index of a non-standard attribute bound in the linked code. More...
GLSLShader * | getComputeShader () const
GLSLShader * | getDomainShader () const
GLSLShader * | getFragmentShader () const
GLSLShader * | getGeometryShader () const
GLuint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLSLShader * | getHullShader () const
GL3PlusOldVertexArrayObject * | getVertexArrayObject ()
GLSLShader * | getVertexShader () const
bool | isAttributeValid (VertexElementSemantic semantic, uint index)
| Is a non-standard attribute bound in the linked code? More...
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
virtual void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)=0
| Updates program object uniforms using data from pass iteration GpuProgramParameters. More...
virtual void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)=0
| Updates program object uniform blocks using data from GpuProgramParameters. More...
virtual void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)=0
| Updates program object uniforms using data from GpuProgramParameters. More...

## Public Attributes
GLint | mBaseInstanceLocation

## Detailed Description

C++ encapsulation of GLSL program object.

## Constructor & Destructor Documentation

## ◆ GLSLProgram()

Ogre::GLSLProgram::GLSLProgram | ( | GLSLShader * | vertexProgram,
|  | GLSLShader * | hullProgram,
|  | GLSLShader * | domainProgram,
|  | GLSLShader * | geometryProgram,
|  | GLSLShader * | fragmentProgram,
|  | GLSLShader * | computeProgram
| ) |  |

Constructor should only be used by GLSLMonolithicProgramManager and GLSLSeparableProgramManager.

## ◆ ~GLSLProgram()

virtual Ogre::GLSLProgram::~GLSLProgram | ( | void |  | ) |
| virtual

## Member Function Documentation

## ◆ activate()

virtual void Ogre::GLSLProgram::activate | ( | void |  | ) |
| pure virtual

Makes a program object active by making sure it is linked and then putting it in use.

Implemented in Ogre::GLSLSeparableProgram, and Ogre::GLSLMonolithicProgram.

## ◆ extractLayoutQualifiers()

virtual void Ogre::GLSLProgram::extractLayoutQualifiers | ( | void |  | ) |
| virtual

Finds layout qualifiers in the shader source and sets attribute indices appropriately.

## ◆ getAttributeIndex()

virtual GLint Ogre::GLSLProgram::getAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| virtual

Get the index of a non-standard attribute bound in the linked code.

Reimplemented in Ogre::GLSLSeparableProgram.

## ◆ getComputeShader()

GLSLShader* Ogre::GLSLProgram::getComputeShader | ( |  | ) | const
| inline

## ◆ getDomainShader()

GLSLShader* Ogre::GLSLProgram::getDomainShader | ( |  | ) | const
| inline

## ◆ getFragmentShader()

GLSLShader* Ogre::GLSLProgram::getFragmentShader | ( |  | ) | const
| inline

## ◆ getGeometryShader()

GLSLShader* Ogre::GLSLProgram::getGeometryShader | ( |  | ) | const
| inline

## ◆ getGLProgramHandle()

GLuint Ogre::GLSLProgram::getGLProgramHandle | ( | void |  | ) | const
| inline

Get the GL Handle for the program object.

## ◆ getHullShader()

GLSLShader* Ogre::GLSLProgram::getHullShader | ( |  | ) | const
| inline

## ◆ getVertexArrayObject()

GL3PlusOldVertexArrayObject* Ogre::GLSLProgram::getVertexArrayObject | ( |  | ) |
| inline

## ◆ getVertexShader()

GLSLShader* Ogre::GLSLProgram::getVertexShader | ( |  | ) | const
| inline

## ◆ isAttributeValid()

bool Ogre::GLSLProgram::isAttributeValid | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |

Is a non-standard attribute bound in the linked code?

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLProgram::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inline

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLProgram::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inline

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ updatePassIterationUniforms()

virtual void Ogre::GLSLProgram::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| pure virtual

Updates program object uniforms using data from pass iteration GpuProgramParameters.

Normally called by GLSLShader::bindMultiPassParameters() just before multi pass rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, and Ogre::GLSLMonolithicProgram.

## ◆ updateUniformBlocks()

virtual void Ogre::GLSLProgram::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| pure virtual

Updates program object uniform blocks using data from GpuProgramParameters.

Normally called by GLSLShader::bindParameters() just before rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, and Ogre::GLSLMonolithicProgram.

## ◆ updateUniforms()

virtual void Ogre::GLSLProgram::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| pure virtual

Updates program object uniforms using data from GpuProgramParameters.

Normally called by GLSLShader::bindParameters() just before rendering occurs.

Implemented in Ogre::GLSLSeparableProgram, and Ogre::GLSLMonolithicProgram.

## Member Data Documentation

## ◆ mBaseInstanceLocation

GLint Ogre::GLSLProgram::mBaseInstanceLocation

The documentation for this class was generated from the following file:

- OgreGLSLProgram.h